<?php
require_once('../../config_session.php');
?>
<?php echo elementTitle('chevron-right', 'System commands'); ?>
<div class="page_element">
	<div class="bmargin15">
		<p class="text_med bpad10">
		The Commands
		</p>
		<p class="sub_text text_small">
		Many action can be taken very fast by using commands. The command must be typed in chat input and you must fill the specific command rank requirement in
		order to be able to use it.
		</p>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/clear
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed either in private or main chat the <span class="theme_color">/clear</span> command will erase logs or clear private conversation. Note that the /clear command will
				work in main chat only for staff members.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/topic
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				When typed followed with some text the <span class="theme_color">/topic</span> command will add a default special welcome message to the room. The topic can
				be set individually for each room. To remove a topic from a room simply use the <span class="theme_color">/topic</span> command without adding text after it.
				This will make topic empty and disabled for the specific room.
				<br/>
				<br/>
				You can use the <span class="theme_color">%user%</span> variable in the topic message this variable will be replaced by the members username.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/seen
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/seen</span> command followed by a username will tell the last time a user has been seen.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/mute
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/mute</span> command followed by a username mute the specified username account.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/unmute
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/unmute</span> command followed by a username unmute the specified username account.
				note that the unmute command will not remove the room mute.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/ban
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/ban</span> command followed by a username ban the specified username account.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/unban
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/unban</span> command followed by a username unban the specified username account.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/verify
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/verify</span> command followed by a username mark as verified the specified username account.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/setuser
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/setuser</span> command followed by a username set the specified username account to user rank and remove previously set rank.
				This command can only be used by admins and owner.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/setvip
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/setvip</span> command followed by a username set the specified username account to vip rank and remove previously set rank.
				This command can only be used by admins and owner.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/setmod
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/setmod</span> command followed by a username set the specified username account to moderator rank and remove previously set rank.
				This command can only be used by admins and owner.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/setadmin
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/setadmin</span> command followed by a username set the specified username account to admin rank and remove previously set rank.
				This command can only be used by admins and owner.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/ignore
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/ignore</span> command followed by a username ignore the specified username account.
				Note that you cannot ignore a staff member.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/removeignore
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/removeignore</span> command followed by a username will remove the specified user from your ignore list.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/addfriend
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/addfriend</span> command followed by a username send a friend request to the specified member if he / she is not already in your friend list.
				Note that Guest do not have access to this command.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/removefriend
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/removefriend</span> command followed by a username remove the specified user from your friend list.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/deleteaccount
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/deleteaccount</span> command followed by a username will delete specified username account.
			</div>
		</div>
	</div>
	<div class="docu_box">
		<div class="docu_head sub_list">
			/clearcache
		</div>
		<div class="docu_content">
			<div class="docu_option_description sub_text">
				If typed in the main chat input the <span class="theme_color">/clearcache</span> command will increase version files and will make people reload new files on their next refresh this command is very useful after
				you make css or jquery modification or system image edit such as logo or favicon.
			</div>
		</div>
	</div>
</div>